/** @file options.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.1
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef OPTIONS_H
#define OPTIONS_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef OPTIONS_PACKAGE
/** @brief the program name */
#define OPTIONS_PACKAGE "pngslice"
#endif

#ifndef OPTIONS_VERSION
/** @brief the program version */
#define OPTIONS_VERSION "0.65"
#endif

/** @brief Where the command line options are stored */
struct gengetopt_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  char * basename_arg;	/**< @brief output file basename.  */
  char * basename_orig;	/**< @brief output file basename original value given at command line.  */
  const char *basename_help; /**< @brief output file basename help description.  */
  int digits_arg;	/**< @brief digits in strip number.  */
  char * digits_orig;	/**< @brief digits in strip number original value given at command line.  */
  const char *digits_help; /**< @brief digits in strip number help description.  */
  int external_flag;	/**< @brief use an external style (default=off).  */
  const char *external_help; /**< @brief use an external style help description.  */
  char * imgpath_arg;	/**< @brief prepend path to image name.  */
  char * imgpath_orig;	/**< @brief prepend path to image name original value given at command line.  */
  const char *imgpath_help; /**< @brief prepend path to image name help description.  */
  int left_flag;	/**< @brief left justify (default) (default=off).  */
  const char *left_help; /**< @brief left justify (default) help description.  */
  char * margins_arg;	/**< @brief left/right margins (em).  */
  char * margins_orig;	/**< @brief left/right margins (em) original value given at command line.  */
  const char *margins_help; /**< @brief left/right margins (em) help description.  */
  int pixels_arg;	/**< @brief height of strip (default='15').  */
  char * pixels_orig;	/**< @brief height of strip original value given at command line.  */
  const char *pixels_help; /**< @brief height of strip help description.  */
  int right_flag;	/**< @brief right justify (default=off).  */
  const char *right_help; /**< @brief right justify help description.  */
  char * trim_arg;	/**< @brief trim colour.  */
  char * trim_orig;	/**< @brief trim colour original value given at command line.  */
  const char *trim_help; /**< @brief trim colour help description.  */
  int verbose_flag;	/**< @brief verbose (default=off).  */
  const char *verbose_help; /**< @brief verbose help description.  */
  int xhtml_flag;	/**< @brief write xhtml rather than html (default=off).  */
  const char *xhtml_help; /**< @brief write xhtml rather than html help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int basename_given ;	/**< @brief Whether basename was given.  */
  unsigned int digits_given ;	/**< @brief Whether digits was given.  */
  unsigned int external_given ;	/**< @brief Whether external was given.  */
  unsigned int imgpath_given ;	/**< @brief Whether imgpath was given.  */
  unsigned int left_given ;	/**< @brief Whether left was given.  */
  unsigned int margins_given ;	/**< @brief Whether margins was given.  */
  unsigned int pixels_given ;	/**< @brief Whether pixels was given.  */
  unsigned int right_given ;	/**< @brief Whether right was given.  */
  unsigned int trim_given ;	/**< @brief Whether trim was given.  */
  unsigned int verbose_given ;	/**< @brief Whether verbose was given.  */
  unsigned int xhtml_given ;	/**< @brief Whether xhtml was given.  */

  char **inputs ; /**< @brief unamed options (options without names) */
  unsigned inputs_num ; /**< @brief unamed options number */
} ;

/** @brief The additional parameters to pass to parser functions */
struct options_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure gengetopt_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure gengetopt_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *gengetopt_args_info_purpose;
/** @brief the usage string of the program */
extern const char *gengetopt_args_info_usage;
/** @brief all the lines making the help output */
extern const char *gengetopt_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int options (int argc, char * const *argv,
  struct gengetopt_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use options_ext() instead
 */
int options2 (int argc, char * const *argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int options_ext (int argc, char * const *argv,
  struct gengetopt_args_info *args_info,
  struct options_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int options_dump(FILE *outfile,
  struct gengetopt_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int options_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

/**
 * Print the help
 */
void options_print_help(void);
/**
 * Print the version
 */
void options_print_version(void);

/**
 * Initializes all the fields a options_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void options_params_init(struct options_params *params);

/**
 * Allocates dynamically a options_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized options_params structure
 */
struct options_params *options_params_create(void);

/**
 * Initializes the passed gengetopt_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void options_init (struct gengetopt_args_info *args_info);
/**
 * Deallocates the string fields of the gengetopt_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void options_free (struct gengetopt_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int options_required (struct gengetopt_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* OPTIONS_H */
